/*  Borland C demo                                  */
/*                                                  */
/*  Please see Visual C samples for more details    */
/*  and Visual C++ programs                         */
/*                                                  */


#include <stdio.h>
#include <windows.h>
#include <conio.h>
#include <memory.h>


#include "..\..\MS Visual C\medefines.h"
#include "..\..\MS Visual C\DLLInit.h"           // for using with dynamic DLL accessing

#ifdef __BORLANDC__
#include <condefs.h>
USEFILE("..\..\MS Visual C\medefines.h");
USEFILE("..\..\MS Visual C\DLLInit.h");
USEUNIT("..\..\MS Visual C\DLLInit.cpp");
#endif

#include <TestConsoleGeneric.c>


int main(int argc, char* argv[])
{
    meOpenDynamicAccess();
    
	// Call generic console function in parent directory to 
	// open system and list the available devices and subdevices.

	int i_number_of_devices = TestConsoleMEIDSProlog();

	if(i_number_of_devices <= 0)
	{
		return(-1);
	}

	// ---------------------------------------------------------------------
	
	printf(	"Press any key to try to lock Device 0, Subdevice 0\n\n");

	getch();
			
	int i_me_error = meLockSubdevice(0, 0, ME_LOCK_SET, 0);

	if(i_me_error != ME_ERRNO_SUCCESS)
	{
		printf("****    meLockSubdevice, ME_LOCK_SET - Error: %d    ****\n\n", i_me_error);
		
		printf("Press any key to terminate\n\n");
		
		meClose(0);
		
		_getch();

		return(-1);
	}

	printf(	"Lock set on Device 0, Subdevice 0\n\n"
			"Press any key to release lock\n\n");

	getch();
			
	i_me_error = meLockSubdevice(0, 0, ME_LOCK_RELEASE, 0);

	if(i_me_error != ME_ERRNO_SUCCESS)
	{
		printf("****    meLockSubdevice, ME_LOCK_RELEASE - Error: %d    ****\n\n", i_me_error);
		
		printf("Press any key to terminate\n\n");
		
		meClose(0);
		
		_getch();

		return(-1);
	}

	meClose(0);
	meCloseDynamicAccess();
	
	printf(	"Lock released on Device 0, Subdevice 0\n\n"
			"Press any key to terminate\n\n");

	getch();
			
	return 0;
}

