// Dlg_M-7_TestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "Dlg_M-7_Test.h"
#include "Dlg_M-7_TestDlg.h"

extern "C"
{
#include "..\\medriver.h"
}

#define ME7_AI_RANGE_BIPOLAR_10_VOLT		        0
#define ME7_AI_RANGE_500_AMPERE				        1
#define ME7_AI_RANGE_50_AMPERE				        2
#define ME7_AI_RANGE_25_AMPERE				        3
#define ME7_AI_RANGE_2500_MILLIAMPERE		        4
#define ME7_AI_RANGE_250_MILLIAMPERE_5_MILLIOHM		5
#define ME7_AI_RANGE_250_MILLIAMPERE		        6
#define ME7_AI_RANGE_25_MILLIAMPERE			        7
#define ME7_AI_RANGE_2500_MICROAMPERE		        8
#define ME7_AI_RANGE_250_MICROAMPERE		        9
#define ME7_AI_RANGE_UNIPOLAR_10_VOLT		        10
#define ME7_AI_RANGE_BIPOLAR_2_5_VOLT		        11
#define ME7_AI_RANGE_UNIPOLAR_2_5_VOLT		        12


#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// CDlg_M7_TestDlg dialog




CDlg_M7_TestDlg::CDlg_M7_TestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDlg_M7_TestDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDlg_M7_TestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CDlg_M7_TestDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_WM_DRAWITEM()
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_0_RANGE_1, &CDlg_M7_TestDlg::OnBnClickedButtonChannel0Range1)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_0_RANGE_2, &CDlg_M7_TestDlg::OnBnClickedButtonChannel0Range2)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_0_RANGE_3, &CDlg_M7_TestDlg::OnBnClickedButtonChannel0Range3)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_0_RANGE_4, &CDlg_M7_TestDlg::OnBnClickedButtonChannel0Range4)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_0_RANGE_5, &CDlg_M7_TestDlg::OnBnClickedButtonChannel0Range5)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_0_RANGE_6, &CDlg_M7_TestDlg::OnBnClickedButtonChannel0Range6)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_0_RANGE_7, &CDlg_M7_TestDlg::OnBnClickedButtonChannel0Range7)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_0_RANGE_8, &CDlg_M7_TestDlg::OnBnClickedButtonChannel0Range8)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_0_RANGE_9, &CDlg_M7_TestDlg::OnBnClickedButtonChannel0Range9)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_1_RANGE_1, &CDlg_M7_TestDlg::OnBnClickedButtonChannel1Range1)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_1_RANGE_2, &CDlg_M7_TestDlg::OnBnClickedButtonChannel1Range2)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_1_RANGE_3, &CDlg_M7_TestDlg::OnBnClickedButtonChannel1Range3)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_1_RANGE_4, &CDlg_M7_TestDlg::OnBnClickedButtonChannel1Range4)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_1_RANGE_5, &CDlg_M7_TestDlg::OnBnClickedButtonChannel1Range5)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_1_RANGE_6, &CDlg_M7_TestDlg::OnBnClickedButtonChannel1Range6)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_1_RANGE_7, &CDlg_M7_TestDlg::OnBnClickedButtonChannel1Range7)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_1_RANGE_8, &CDlg_M7_TestDlg::OnBnClickedButtonChannel1Range8)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_1_RANGE_9, &CDlg_M7_TestDlg::OnBnClickedButtonChannel1Range9)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_2_RANGE_1, &CDlg_M7_TestDlg::OnBnClickedButtonChannel2Range1)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_2_RANGE_2, &CDlg_M7_TestDlg::OnBnClickedButtonChannel2Range2)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_2_RANGE_3, &CDlg_M7_TestDlg::OnBnClickedButtonChannel2Range3)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_2_RANGE_4, &CDlg_M7_TestDlg::OnBnClickedButtonChannel2Range4)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_2_RANGE_5, &CDlg_M7_TestDlg::OnBnClickedButtonChannel2Range5)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_2_RANGE_6, &CDlg_M7_TestDlg::OnBnClickedButtonChannel2Range6)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_2_RANGE_7, &CDlg_M7_TestDlg::OnBnClickedButtonChannel2Range7)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_2_RANGE_8, &CDlg_M7_TestDlg::OnBnClickedButtonChannel2Range8)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_2_RANGE_9, &CDlg_M7_TestDlg::OnBnClickedButtonChannel2Range9)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_3_RANGE_1, &CDlg_M7_TestDlg::OnBnClickedButtonChannel3Range1)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_3_RANGE_2, &CDlg_M7_TestDlg::OnBnClickedButtonChannel3Range2)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_3_RANGE_3, &CDlg_M7_TestDlg::OnBnClickedButtonChannel3Range3)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_3_RANGE_4, &CDlg_M7_TestDlg::OnBnClickedButtonChannel3Range4)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_3_RANGE_5, &CDlg_M7_TestDlg::OnBnClickedButtonChannel3Range5)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_3_RANGE_6, &CDlg_M7_TestDlg::OnBnClickedButtonChannel3Range6)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_3_RANGE_7, &CDlg_M7_TestDlg::OnBnClickedButtonChannel3Range7)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_3_RANGE_8, &CDlg_M7_TestDlg::OnBnClickedButtonChannel3Range8)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_3_RANGE_9, &CDlg_M7_TestDlg::OnBnClickedButtonChannel3Range9)
	ON_BN_CLICKED(IDC_BUTTON_MEASURE, &CDlg_M7_TestDlg::OnBnClickedMeasure)
	ON_BN_CLICKED(IDC_BUTTON_ZERO_ADJUST_CHANNEL_0, &CDlg_M7_TestDlg::OnBnClickedButtonZeroAdjustChannel0)
	ON_BN_CLICKED(IDC_BUTTON_ZERO_ADJUST_CHANNEL_1, &CDlg_M7_TestDlg::OnBnClickedButtonZeroAdjustChannel1)
	ON_BN_CLICKED(IDC_BUTTON_ZERO_ADJUST_CHANNEL_2, &CDlg_M7_TestDlg::OnBnClickedButtonZeroAdjustChannel2)
	ON_BN_CLICKED(IDC_BUTTON_ZERO_ADJUST_CHANNEL_3, &CDlg_M7_TestDlg::OnBnClickedButtonZeroAdjustChannel3)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_4_RANGE_0, &CDlg_M7_TestDlg::OnBnClickedButtonChannel4Range0)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_4_RANGE_10, &CDlg_M7_TestDlg::OnBnClickedButtonChannel4Range10)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_4_RANGE_11, &CDlg_M7_TestDlg::OnBnClickedButtonChannel4Range11)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_4_RANGE_12, &CDlg_M7_TestDlg::OnBnClickedButtonChannel4Range12)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_5_RANGE_0, &CDlg_M7_TestDlg::OnBnClickedButtonChannel5Range0)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_5_RANGE_10, &CDlg_M7_TestDlg::OnBnClickedButtonChannel5Range10)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_5_RANGE_11, &CDlg_M7_TestDlg::OnBnClickedButtonChannel5Range11)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_5_RANGE_12, &CDlg_M7_TestDlg::OnBnClickedButtonChannel5Range12)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_6_RANGE_0, &CDlg_M7_TestDlg::OnBnClickedButtonChannel6Range0)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_6_RANGE_10, &CDlg_M7_TestDlg::OnBnClickedButtonChannel6Range10)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_6_RANGE_11, &CDlg_M7_TestDlg::OnBnClickedButtonChannel6Range11)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_6_RANGE_12, &CDlg_M7_TestDlg::OnBnClickedButtonChannel6Range12)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_7_RANGE_0, &CDlg_M7_TestDlg::OnBnClickedButtonChannel7Range0)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_7_RANGE_10, &CDlg_M7_TestDlg::OnBnClickedButtonChannel7Range10)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_7_RANGE_11, &CDlg_M7_TestDlg::OnBnClickedButtonChannel7Range11)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_7_RANGE_12, &CDlg_M7_TestDlg::OnBnClickedButtonChannel7Range12)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_8_RANGE_0, &CDlg_M7_TestDlg::OnBnClickedButtonChannel8Range0)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_8_RANGE_10, &CDlg_M7_TestDlg::OnBnClickedButtonChannel8Range10)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_8_RANGE_11, &CDlg_M7_TestDlg::OnBnClickedButtonChannel8Range11)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_8_RANGE_12, &CDlg_M7_TestDlg::OnBnClickedButtonChannel8Range12)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_9_RANGE_0, &CDlg_M7_TestDlg::OnBnClickedButtonChannel9Range0)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_9_RANGE_10, &CDlg_M7_TestDlg::OnBnClickedButtonChannel9Range10)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_9_RANGE_11, &CDlg_M7_TestDlg::OnBnClickedButtonChannel9Range11)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_9_RANGE_12, &CDlg_M7_TestDlg::OnBnClickedButtonChannel9Range12)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_10_RANGE_0, &CDlg_M7_TestDlg::OnBnClickedButtonChannel10Range0)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_10_RANGE_10, &CDlg_M7_TestDlg::OnBnClickedButtonChannel10Range10)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_10_RANGE_11, &CDlg_M7_TestDlg::OnBnClickedButtonChannel10Range11)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_10_RANGE_12, &CDlg_M7_TestDlg::OnBnClickedButtonChannel10Range12)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_11_RANGE_0, &CDlg_M7_TestDlg::OnBnClickedButtonChannel11Range0)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_11_RANGE_10, &CDlg_M7_TestDlg::OnBnClickedButtonChannel11Range10)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_11_RANGE_11, &CDlg_M7_TestDlg::OnBnClickedButtonChannel11Range11)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_11_RANGE_12, &CDlg_M7_TestDlg::OnBnClickedButtonChannel11Range12)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_12_RANGE_0, &CDlg_M7_TestDlg::OnBnClickedButtonChannel12Range0)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_12_RANGE_10, &CDlg_M7_TestDlg::OnBnClickedButtonChannel12Range10)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_12_RANGE_11, &CDlg_M7_TestDlg::OnBnClickedButtonChannel12Range11)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_12_RANGE_12, &CDlg_M7_TestDlg::OnBnClickedButtonChannel12Range12)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_13_RANGE_0, &CDlg_M7_TestDlg::OnBnClickedButtonChannel13Range0)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_13_RANGE_10, &CDlg_M7_TestDlg::OnBnClickedButtonChannel13Range10)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_13_RANGE_11, &CDlg_M7_TestDlg::OnBnClickedButtonChannel13Range11)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_13_RANGE_12, &CDlg_M7_TestDlg::OnBnClickedButtonChannel13Range12)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_14_RANGE_0, &CDlg_M7_TestDlg::OnBnClickedButtonChannel14Range0)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_14_RANGE_10, &CDlg_M7_TestDlg::OnBnClickedButtonChannel14Range10)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_14_RANGE_11, &CDlg_M7_TestDlg::OnBnClickedButtonChannel14Range11)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_14_RANGE_12, &CDlg_M7_TestDlg::OnBnClickedButtonChannel14Range12)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_15_RANGE_0, &CDlg_M7_TestDlg::OnBnClickedButtonChannel15Range0)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_15_RANGE_10, &CDlg_M7_TestDlg::OnBnClickedButtonChannel15Range10)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_15_RANGE_11, &CDlg_M7_TestDlg::OnBnClickedButtonChannel15Range11)
	ON_BN_CLICKED(IDC_BUTTON_CHANNEL_15_RANGE_12, &CDlg_M7_TestDlg::OnBnClickedButtonChannel15Range12)
END_MESSAGE_MAP()


// CDlg_M7_TestDlg message handlers

BOOL CDlg_M7_TestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	if(m_iNumberOfCurrentChannels == 2)
	{
		GetDlgItem(IDC_UNIT_CHANNEL_2)->SetWindowText(L"Volt");

		GetDlgItem(IDC_UNIT_CHANNEL_3)->SetWindowText(L"Volt");

		for(int i_range = 1; i_range <= 9; i_range++)
		{
			GetDlgItem(IDC_BUTTON_CHANNEL_2_RANGE_1 + i_range - 1)->ShowWindow(SW_HIDE);
			
			GetDlgItem(IDC_BUTTON_CHANNEL_3_RANGE_1 + i_range - 1)->ShowWindow(SW_HIDE);
		}

		GetDlgItem(IDC_BUTTON_ZERO_ADJUST_CHANNEL_2)->ShowWindow(SW_HIDE);

		GetDlgItem(IDC_BUTTON_ZERO_ADJUST_CHANNEL_3)->ShowWindow(SW_HIDE);
	}
	else
	{
		GetDlgItem(IDC_UNIT_CHANNEL_2)->SetWindowText(L"Ampere");

		GetDlgItem(IDC_UNIT_CHANNEL_3)->SetWindowText(L"Ampere");
	}

	int i_channel;
	
	for(i_channel = 0; i_channel < m_iNumberOfCurrentChannels; i_channel++)
	{
		meIOSingleConfig(	m_iME7DeviceIndex,					// iDevice,
							m_iME7AISubdeviceIndex,				// iSubdevice,
							i_channel,							// iChannel
							ME7_AI_RANGE_50_AMPERE,				// iSingleConfig (range index)
							ME_REF_AI_GROUND,					// Reference
							ME_TRIG_CHAN_DEFAULT,				// Trigger channel - standard
							ME_TRIG_TYPE_SW,					// Trigger type - software
							ME_VALUE_NOT_USED,					// Trigger edge - not applicable
							ME_IO_SINGLE_CONFIG_NO_FLAGS	);	// Flags

		m_iCurrentRange[i_channel] = ME7_AI_RANGE_50_AMPERE;
	}

	for(; i_channel < 16; i_channel++)
	{
		meIOSingleConfig(	m_iME7DeviceIndex,					// iDevice,
							m_iME7AISubdeviceIndex,				// iSubdevice,
							i_channel,							// iChannel
							ME7_AI_RANGE_BIPOLAR_10_VOLT,		// iSingleConfig (range index)
							ME_REF_AI_GROUND,					// Reference
							ME_TRIG_CHAN_DEFAULT,				// Trigger channel - standard
							ME_TRIG_TYPE_SW,					// Trigger type - software
							ME_VALUE_NOT_USED,					// Trigger edge - not applicable
							ME_IO_SINGLE_CONFIG_NO_FLAGS	);	// Flags

		m_iCurrentRange[i_channel] = ME7_AI_RANGE_BIPOLAR_10_VOLT; 
	}

	int i_unit;

	for(int index_range = 0; index_range < 13; index_range++)
	{
		int i_me_error = i_me_error = meQueryRangeInfo(	m_iME7DeviceIndex,								// Device index
														m_iME7AISubdeviceIndex,							// Subdevice index, 
														index_range,									// Range index
														&i_unit,										// Unit returned here - not require
														&m_arrRanges[index_range].m_dPhysicalMin,		// Physical minimum returned here
														&m_arrRanges[index_range].m_dPhysicalMax,		// Physical maximum returned here
														&m_arrRanges[index_range].m_iDigitalMax		);	// Digital maximum value returned here
	}

	int i_me_error = meIOIrqSetCallback(m_iME7DeviceIndex,					// Device index
										m_iME7AISubdeviceIndex,				// Subdevice index
										IrqCallback,						// Callback routine
										this,								// Callback contextz
										ME_IO_IRQ_SET_CALLBACK_NO_FLAGS	);	// Flags


	i_me_error =  meIOIrqStart(	m_iME7DeviceIndex,				// Device index
								m_iME7AISubdeviceIndex,			// Subdevice index
								0,								// Channel index 	
								0,								// IRQ source
								0,								// Type of signal edge
								0,								// Additional argument - Not required here
								ME_IO_IRQ_START_NO_FLAGS	);	// Flags


	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CDlg_M7_TestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDlg_M7_TestDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDlg_M7_TestDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CDlg_M7_TestDlg::OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	// TODO: Add your message handler code here and/or call default

//	CDialog::OnDrawItem(nIDCtl, lpDrawItemStruct);

	if(lpDrawItemStruct->CtlType == ODT_BUTTON)
	{
		{
			UINT uStyle = DFCS_BUTTONPUSH;

			ASSERT(lpDrawItemStruct->CtlType == ODT_BUTTON);

			if (lpDrawItemStruct->itemState & ODS_SELECTED)
			{
			  uStyle |= DFCS_PUSHED;
			}

			// Draw the button frame.
			::DrawFrameControl(lpDrawItemStruct->hDC, &lpDrawItemStruct->rcItem, DFC_BUTTON, uStyle);

			lpDrawItemStruct->rcItem.left+= 2;
			
			lpDrawItemStruct->rcItem.top+= 2;
			
			lpDrawItemStruct->rcItem.right-= 2;
			
			lpDrawItemStruct->rcItem.bottom-= 2;
			
			COLORREF cr_color_button;
			
			if( (IDC_BUTTON_CHANNEL_0_RANGE_1 <= nIDCtl)&&(nIDCtl <= IDC_BUTTON_CHANNEL_0_RANGE_9) )
			{
				if( (lpDrawItemStruct->itemState & ODS_DISABLED) == ODS_DISABLED )
				{
					cr_color_button = RGB(0xC0, 0xC0, 0xC0);
				}
				else
				{
					if( m_iCurrentRange[0] == (nIDCtl - IDC_BUTTON_CHANNEL_0_RANGE_1 + 1) )
					{
						cr_color_button = RGB(0x00, 0xC0, 0x00);
					}
					else
					{
						cr_color_button = RGB(0xC0, 0x00, 0x00);
					}
				}
			}
			
			if( (IDC_BUTTON_CHANNEL_1_RANGE_1 <= nIDCtl)&&(nIDCtl <= IDC_BUTTON_CHANNEL_1_RANGE_9) )
			{
				if( (lpDrawItemStruct->itemState & ODS_DISABLED) == ODS_DISABLED )
				{
					cr_color_button = RGB(0xC0, 0xC0, 0xC0);
				}
				else
				{
					if( m_iCurrentRange[1] == (nIDCtl - IDC_BUTTON_CHANNEL_1_RANGE_1 + 1) )
					{
						cr_color_button = RGB(0x00, 0xC0, 0x00);
					}
					else
					{
						cr_color_button = RGB(0xC0, 0x00, 0x00);
					}
				}
			}

			if(m_iNumberOfCurrentChannels == 4)
			{
				if( (IDC_BUTTON_CHANNEL_2_RANGE_1 <= nIDCtl)&&(nIDCtl <= IDC_BUTTON_CHANNEL_2_RANGE_9) )
				{
					if( (lpDrawItemStruct->itemState & ODS_DISABLED) == ODS_DISABLED )
					{
						cr_color_button = RGB(0xC0, 0xC0, 0xC0);
					}
					else
					{
						if( m_iCurrentRange[2] == (nIDCtl - IDC_BUTTON_CHANNEL_2_RANGE_1 + 1) )
						{
							cr_color_button = RGB(0x00, 0xC0, 0x00);
						}
						else
						{
							cr_color_button = RGB(0xC0, 0x00, 0x00);
						}
					}
				}
				
				if( (IDC_BUTTON_CHANNEL_3_RANGE_1 <= nIDCtl)&&(nIDCtl <= IDC_BUTTON_CHANNEL_3_RANGE_9) )
				{
					if( (lpDrawItemStruct->itemState & ODS_DISABLED) == ODS_DISABLED )
					{
						cr_color_button = RGB(0xC0, 0xC0, 0xC0);
					}
					else
					{
						if( m_iCurrentRange[3] == (nIDCtl - IDC_BUTTON_CHANNEL_3_RANGE_1 + 1) )
						{
							cr_color_button = RGB(0x00, 0xC0, 0x00);
						}
						else
						{
							cr_color_button = RGB(0xC0, 0x00, 0x00);
						}
					}
				}
			}

			if( (IDC_BUTTON_CHANNEL_4_RANGE_0 <= nIDCtl)&&(nIDCtl <= IDC_BUTTON_CHANNEL_4_RANGE_12) )
			{
				if( (lpDrawItemStruct->itemState & ODS_DISABLED) == ODS_DISABLED )
				{
					cr_color_button = RGB(0xC0, 0xC0, 0xC0);
				}
				else
				{
					if( ( ( m_iCurrentRange[4] == 0)&&(nIDCtl == IDC_BUTTON_CHANNEL_4_RANGE_0) )||
								(m_iCurrentRange[4] == nIDCtl - IDC_BUTTON_CHANNEL_4_RANGE_10 + 10) )
					{
						cr_color_button = RGB(0x00, 0xC0, 0x00);
					}
					else
					{
						cr_color_button = RGB(0xC0, 0x00, 0x00);
					}
				}
			}

			if( (IDC_BUTTON_CHANNEL_5_RANGE_0 <= nIDCtl)&&(nIDCtl <= IDC_BUTTON_CHANNEL_5_RANGE_12) )
			{
				if( (lpDrawItemStruct->itemState & ODS_DISABLED) == ODS_DISABLED )
				{
					cr_color_button = RGB(0xC0, 0xC0, 0xC0);
				}
				else
				{
					if( ( ( m_iCurrentRange[5] == 0)&&(nIDCtl == IDC_BUTTON_CHANNEL_5_RANGE_0) )||
								(m_iCurrentRange[5] == nIDCtl - IDC_BUTTON_CHANNEL_5_RANGE_10 + 10) )
					{
						cr_color_button = RGB(0x00, 0xC0, 0x00);
					}
					else
					{
						cr_color_button = RGB(0xC0, 0x00, 0x00);
					}
				}
			}
			if( (IDC_BUTTON_CHANNEL_6_RANGE_0 <= nIDCtl)&&(nIDCtl <= IDC_BUTTON_CHANNEL_6_RANGE_12) )
			{
				if( (lpDrawItemStruct->itemState & ODS_DISABLED) == ODS_DISABLED )
				{
					cr_color_button = RGB(0xC0, 0xC0, 0xC0);
				}
				else
				{
					if( ( ( m_iCurrentRange[6] == 0)&&(nIDCtl == IDC_BUTTON_CHANNEL_6_RANGE_0) )||
								(m_iCurrentRange[6] == nIDCtl - IDC_BUTTON_CHANNEL_5_RANGE_10 + 10) )
					{
						cr_color_button = RGB(0x00, 0xC0, 0x00);
					}
					else
					{
						cr_color_button = RGB(0xC0, 0x00, 0x00);
					}
				}
			}
			if( (IDC_BUTTON_CHANNEL_7_RANGE_0 <= nIDCtl)&&(nIDCtl <= IDC_BUTTON_CHANNEL_7_RANGE_12) )
			{
				if( (lpDrawItemStruct->itemState & ODS_DISABLED) == ODS_DISABLED )
				{
					cr_color_button = RGB(0xC0, 0xC0, 0xC0);
				}
				else
				{
					if( ( ( m_iCurrentRange[7] == 0)&&(nIDCtl == IDC_BUTTON_CHANNEL_7_RANGE_0) )||
								(m_iCurrentRange[7] == nIDCtl - IDC_BUTTON_CHANNEL_7_RANGE_10 + 10) )
					{
						cr_color_button = RGB(0x00, 0xC0, 0x00);
					}
					else
					{
						cr_color_button = RGB(0xC0, 0x00, 0x00);
					}
				}
			}
			if( (IDC_BUTTON_CHANNEL_8_RANGE_0 <= nIDCtl)&&(nIDCtl <= IDC_BUTTON_CHANNEL_8_RANGE_12) )
			{
				if( (lpDrawItemStruct->itemState & ODS_DISABLED) == ODS_DISABLED )
				{
					cr_color_button = RGB(0xC0, 0xC0, 0xC0);
				}
				else
				{
					if( ( ( m_iCurrentRange[8] == 0)&&(nIDCtl == IDC_BUTTON_CHANNEL_8_RANGE_0) )||
								(m_iCurrentRange[8] == nIDCtl - IDC_BUTTON_CHANNEL_8_RANGE_10 + 10) )
					{
						cr_color_button = RGB(0x00, 0xC0, 0x00);
					}
					else
					{
						cr_color_button = RGB(0xC0, 0x00, 0x00);
					}
				}
			}
			if( (IDC_BUTTON_CHANNEL_9_RANGE_0 <= nIDCtl)&&(nIDCtl <= IDC_BUTTON_CHANNEL_9_RANGE_12) )
			{
				if( (lpDrawItemStruct->itemState & ODS_DISABLED) == ODS_DISABLED )
				{
					cr_color_button = RGB(0xC0, 0xC0, 0xC0);
				}
				else
				{
					if( ( ( m_iCurrentRange[9] == 0)&&(nIDCtl == IDC_BUTTON_CHANNEL_9_RANGE_0) )||
								(m_iCurrentRange[9] == nIDCtl - IDC_BUTTON_CHANNEL_9_RANGE_10 + 10) )
					{
						cr_color_button = RGB(0x00, 0xC0, 0x00);
					}
					else
					{
						cr_color_button = RGB(0xC0, 0x00, 0x00);
					}
				}
			}
			if( (IDC_BUTTON_CHANNEL_10_RANGE_0 <= nIDCtl)&&(nIDCtl <= IDC_BUTTON_CHANNEL_10_RANGE_12) )
			{
				if( (lpDrawItemStruct->itemState & ODS_DISABLED) == ODS_DISABLED )
				{
					cr_color_button = RGB(0xC0, 0xC0, 0xC0);
				}
				else
				{
					if( ( ( m_iCurrentRange[10] == 0)&&(nIDCtl == IDC_BUTTON_CHANNEL_10_RANGE_0) )||
								(m_iCurrentRange[10] == nIDCtl - IDC_BUTTON_CHANNEL_10_RANGE_10 + 10) )
					{
						cr_color_button = RGB(0x00, 0xC0, 0x00);
					}
					else
					{
						cr_color_button = RGB(0xC0, 0x00, 0x00);
					}
				}
			}
			if( (IDC_BUTTON_CHANNEL_11_RANGE_0 <= nIDCtl)&&(nIDCtl <= IDC_BUTTON_CHANNEL_11_RANGE_12) )
			{
				if( (lpDrawItemStruct->itemState & ODS_DISABLED) == ODS_DISABLED )
				{
					cr_color_button = RGB(0xC0, 0xC0, 0xC0);
				}
				else
				{
					if( ( ( m_iCurrentRange[11] == 0)&&(nIDCtl == IDC_BUTTON_CHANNEL_11_RANGE_0) )||
								(m_iCurrentRange[11] == nIDCtl - IDC_BUTTON_CHANNEL_11_RANGE_10 + 10) )
					{
						cr_color_button = RGB(0x00, 0xC0, 0x00);
					}
					else
					{
						cr_color_button = RGB(0xC0, 0x00, 0x00);
					}
				}
			}
			if( (IDC_BUTTON_CHANNEL_12_RANGE_0 <= nIDCtl)&&(nIDCtl <= IDC_BUTTON_CHANNEL_12_RANGE_12) )
			{
				if( (lpDrawItemStruct->itemState & ODS_DISABLED) == ODS_DISABLED )
				{
					cr_color_button = RGB(0xC0, 0xC0, 0xC0);
				}
				else
				{
					if( ( ( m_iCurrentRange[12] == 0)&&(nIDCtl == IDC_BUTTON_CHANNEL_12_RANGE_0) )||
								(m_iCurrentRange[12] == nIDCtl - IDC_BUTTON_CHANNEL_12_RANGE_10 + 10) )
					{
						cr_color_button = RGB(0x00, 0xC0, 0x00);
					}
					else
					{
						cr_color_button = RGB(0xC0, 0x00, 0x00);
					}
				}
			}
			if( (IDC_BUTTON_CHANNEL_13_RANGE_0 <= nIDCtl)&&(nIDCtl <= IDC_BUTTON_CHANNEL_13_RANGE_12) )
			{
				if( (lpDrawItemStruct->itemState & ODS_DISABLED) == ODS_DISABLED )
				{
					cr_color_button = RGB(0xC0, 0xC0, 0xC0);
				}
				else
				{
					if( ( ( m_iCurrentRange[13] == 0)&&(nIDCtl == IDC_BUTTON_CHANNEL_13_RANGE_0) )||
								(m_iCurrentRange[13] == nIDCtl - IDC_BUTTON_CHANNEL_13_RANGE_10 + 10) )
					{
						cr_color_button = RGB(0x00, 0xC0, 0x00);
					}
					else
					{
						cr_color_button = RGB(0xC0, 0x00, 0x00);
					}
				}
			}
			if( (IDC_BUTTON_CHANNEL_14_RANGE_0 <= nIDCtl)&&(nIDCtl <= IDC_BUTTON_CHANNEL_14_RANGE_12) )
			{
				if( (lpDrawItemStruct->itemState & ODS_DISABLED) == ODS_DISABLED )
				{
					cr_color_button = RGB(0xC0, 0xC0, 0xC0);
				}
				else
				{
					if( ( ( m_iCurrentRange[14] == 0)&&(nIDCtl == IDC_BUTTON_CHANNEL_14_RANGE_0) )||
								(m_iCurrentRange[14] == nIDCtl - IDC_BUTTON_CHANNEL_14_RANGE_10 + 10) )
					{
						cr_color_button = RGB(0x00, 0xC0, 0x00);
					}
					else
					{
						cr_color_button = RGB(0xC0, 0x00, 0x00);
					}
				}
			}
			if( (IDC_BUTTON_CHANNEL_15_RANGE_0 <= nIDCtl)&&(nIDCtl <= IDC_BUTTON_CHANNEL_15_RANGE_12) )
			{
				if( (lpDrawItemStruct->itemState & ODS_DISABLED) == ODS_DISABLED )
				{
					cr_color_button = RGB(0xC0, 0xC0, 0xC0);
				}
				else
				{
					if( ( ( m_iCurrentRange[15] == 0)&&(nIDCtl == IDC_BUTTON_CHANNEL_15_RANGE_0) )||
								(m_iCurrentRange[15] == nIDCtl - IDC_BUTTON_CHANNEL_15_RANGE_10 + 10) )
					{
						cr_color_button = RGB(0x00, 0xC0, 0x00);
					}
					else
					{
						cr_color_button = RGB(0xC0, 0x00, 0x00);
					}
				}
			}

			HBRUSH h_brush = CreateSolidBrush(cr_color_button);
			
			FillRect(lpDrawItemStruct->hDC, &lpDrawItemStruct->rcItem, h_brush);

			DeleteObject(h_brush);

			int old_bk_color = SetBkColor(lpDrawItemStruct->hDC, cr_color_button);
			
			_TCHAR buffer[128];
			
			::GetWindowText(lpDrawItemStruct->hwndItem, &buffer[0], 128);
			
			DrawText(	lpDrawItemStruct->hDC,						// handle to DC
						&buffer[0],									// text to draw	
						_tcslen(&buffer[0]),						// text length	
						&lpDrawItemStruct->rcItem,					// formatting dimensions
						DT_CENTER | DT_SINGLELINE | DT_VCENTER	);  // text-drawing options

			SetBkColor(lpDrawItemStruct->hDC, old_bk_color);
		}
	}
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel0Range1()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(0, 1);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel0Range2()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(0, 2);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel0Range3()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(0, 3);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel0Range4()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(0, 4);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel0Range5()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(0, 5);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel0Range6()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(0, 6);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel0Range7()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(0, 7);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel0Range8()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(0, 8);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel0Range9()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(0, 9);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel1Range1()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(1, 1);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel1Range2()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(1, 2);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel1Range3()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(1, 3);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel1Range4()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(1, 4);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel1Range5()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(1, 5);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel1Range6()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(1, 6);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel1Range7()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(1, 7);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel1Range8()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(1, 8);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel1Range9()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(1, 9);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel2Range1()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(2, 1);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel2Range2()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(2, 2);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel2Range3()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(2, 3);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel2Range4()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(2, 4);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel2Range5()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(2, 5);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel2Range6()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(2, 6);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel2Range7()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(2, 7);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel2Range8()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(2, 8);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel2Range9()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(2, 9);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel3Range1()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(3, 1);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel3Range2()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(3, 2);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel3Range3()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(3, 3);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel3Range4()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(3, 4);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel3Range5()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(3, 5);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel3Range6()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(3, 6);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel3Range7()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(3, 7);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel3Range8()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(3, 8);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel3Range9()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(3, 9);
}

void CDlg_M7_TestDlg::SetChannelRange(int iChannel, int iRange)
{
	if(m_iCurrentRange[iChannel] == iRange)
	{
		return;
	}

	unsigned int ui_old_button_id = GetButtonControlID(iChannel, m_iCurrentRange[iChannel]);

	meIOSingleConfig(	m_iME7DeviceIndex,					// iDevice,
						m_iME7AISubdeviceIndex,				// iSubdevice,
						iChannel,							// iChannel
						iRange,								// iSingleConfig (range index)
						ME_REF_AI_GROUND,					// Reference
						ME_TRIG_CHAN_DEFAULT,				// Trigger channel - standard
						ME_TRIG_TYPE_SW,					// Trigger type - software
						ME_VALUE_NOT_USED,					// Trigger edge - not applicable
						ME_IO_SINGLE_CONFIG_NO_FLAGS	);	// Flags

	m_iCurrentRange[iChannel] = iRange;

	unsigned int ui_new_button_id = GetButtonControlID(iChannel, m_iCurrentRange[iChannel]);

	GetDlgItem(ui_old_button_id)->Invalidate();

	GetDlgItem(ui_new_button_id)->Invalidate();
}

unsigned int CDlg_M7_TestDlg::GetButtonControlID(int iChannel, int iRange)
{
	unsigned int ui_ctrl_id;

	switch(iChannel)
	{
	case 0:

		ui_ctrl_id = IDC_BUTTON_CHANNEL_0_RANGE_1 + (unsigned int)iRange - 1;	

		break;

	case 1:

		ui_ctrl_id = IDC_BUTTON_CHANNEL_1_RANGE_1 + (unsigned int)iRange - 1;	

		break;

	case 2:

		ui_ctrl_id = IDC_BUTTON_CHANNEL_2_RANGE_1 + (unsigned int)iRange - 1;	

		break;

	case 3:

		ui_ctrl_id = IDC_BUTTON_CHANNEL_3_RANGE_1 + (unsigned int)iRange - 1;	

		break;

	case 4:

		if(iRange == 0)
		{
			ui_ctrl_id = IDC_BUTTON_CHANNEL_4_RANGE_0;
		}
		else
		{
			ui_ctrl_id = IDC_BUTTON_CHANNEL_4_RANGE_10 + (iRange - 10);
		}

		break;

	case 5:

		if(iRange == 0)
		{
			ui_ctrl_id = IDC_BUTTON_CHANNEL_5_RANGE_0;
		}
		else
		{
			ui_ctrl_id = IDC_BUTTON_CHANNEL_5_RANGE_10 + (iRange - 10);
		}

		break;

	case 6:

		if(iRange == 0)
		{
			ui_ctrl_id = IDC_BUTTON_CHANNEL_6_RANGE_0;
		}
		else
		{
			ui_ctrl_id = IDC_BUTTON_CHANNEL_6_RANGE_10 + (iRange - 10);
		}

		break;

	case 7:

		if(iRange == 0)
		{
			ui_ctrl_id = IDC_BUTTON_CHANNEL_7_RANGE_0;
		}
		else
		{
			ui_ctrl_id = IDC_BUTTON_CHANNEL_7_RANGE_10 + (iRange - 10);
		}

		break;

	case 8:

		if(iRange == 0)
		{
			ui_ctrl_id = IDC_BUTTON_CHANNEL_8_RANGE_0;
		}
		else
		{
			ui_ctrl_id = IDC_BUTTON_CHANNEL_8_RANGE_10 + (iRange - 10);
		}

		break;

	case 9:

		if(iRange == 0)
		{
			ui_ctrl_id = IDC_BUTTON_CHANNEL_9_RANGE_0;
		}
		else
		{
			ui_ctrl_id = IDC_BUTTON_CHANNEL_9_RANGE_10 + (iRange - 10);
		}

		break;

	case 10:

		if(iRange == 0)
		{
			ui_ctrl_id = IDC_BUTTON_CHANNEL_10_RANGE_0;
		}
		else
		{
			ui_ctrl_id = IDC_BUTTON_CHANNEL_10_RANGE_10 + (iRange - 10);
		}

		break;

	case 11:

		if(iRange == 0)
		{
			ui_ctrl_id = IDC_BUTTON_CHANNEL_11_RANGE_0;
		}
		else
		{
			ui_ctrl_id = IDC_BUTTON_CHANNEL_11_RANGE_10 + (iRange - 10);
		}

		break;

	case 12:

		if(iRange == 0)
		{
			ui_ctrl_id = IDC_BUTTON_CHANNEL_12_RANGE_0;
		}
		else
		{
			ui_ctrl_id = IDC_BUTTON_CHANNEL_12_RANGE_10 + (iRange - 10);
		}

		break;

	case 13:

		if(iRange == 0)
		{
			ui_ctrl_id = IDC_BUTTON_CHANNEL_13_RANGE_0;
		}
		else
		{
			ui_ctrl_id = IDC_BUTTON_CHANNEL_13_RANGE_10 + (iRange - 10);
		}

		break;

	case 14:

		if(iRange == 0)
		{
			ui_ctrl_id = IDC_BUTTON_CHANNEL_14_RANGE_0;
		}
		else
		{
			ui_ctrl_id = IDC_BUTTON_CHANNEL_14_RANGE_10 + (iRange - 10);
		}

		break;

	case 15:

		if(iRange == 0)
		{
			ui_ctrl_id = IDC_BUTTON_CHANNEL_15_RANGE_0;
		}
		else
		{
			ui_ctrl_id = IDC_BUTTON_CHANNEL_15_RANGE_10 + (iRange - 10);
		}

		break;
	}

	return(ui_ctrl_id);
}


void CDlg_M7_TestDlg::OnBnClickedMeasure()
{
	// TODO: Add your control notification handler code here

	meIOSingle_t io_single[16];

	for(int index_channel = 0; index_channel < 16; index_channel++)
	{
		io_single[index_channel].iDevice = m_iME7DeviceIndex;

		io_single[index_channel].iSubdevice = m_iME7AISubdeviceIndex;
		io_single[index_channel].iChannel	= index_channel;
		io_single[index_channel].iDir		= ME_DIR_INPUT;
		io_single[index_channel].iValue		= 0;
		io_single[index_channel].iTimeOut	= 0;							// No timeout - not required for software output
		io_single[index_channel].iFlags		= ME_IO_SINGLE_TYPE_NO_FLAGS;
	}
	
	int i_me_error = meIOSingle(&io_single[0],				// Output list 
								16,							// Number of elements in the above list 
								ME_IO_SINGLE_NO_FLAGS	);	// Flags


	for(int index_channel = 0; index_channel < 16; index_channel++)
	{
		double d_physical_value;
		
		i_me_error = meUtilityDigitalToPhysical(m_arrRanges[ m_iCurrentRange[index_channel] ].m_dPhysicalMin,		// Minimum physiacal value
												m_arrRanges[ m_iCurrentRange[index_channel] ].m_dPhysicalMax,		// Maximum physical value
												m_arrRanges[ m_iCurrentRange[index_channel] ].m_iDigitalMax,		// Maximum digital value
												io_single[index_channel].iValue,									// Digital value to convert
												ME_VALUE_NOT_USED,													// Module type - not required
												0.0,																// Reference value - not required
												&d_physical_value												);	// Corresponding physical value returned here

		wchar_t wsz_physical_value[64];

		swprintf(&wsz_physical_value[0], L"%12.7f", d_physical_value);

		SetDlgItemText( IDC_VALUE_CHANNEL_0 + index_channel, &wsz_physical_value[0] );
	}
}

int _stdcall CDlg_M7_TestDlg::IrqCallback(int iDevice, int iSubdevice, int iChannel, 
											int iIrqCount, int iValue, void *pvContext, int iErrorCode)
{
	Beep(250, 500);

	CDlg_M7_TestDlg* p_dlg = (CDlg_M7_TestDlg*)pvContext;

	int i_mask = 0x00000003;

	for(int index_channel = 0; index_channel < p_dlg->m_iNumberOfCurrentChannels; index_channel++)
	{
		if( (iValue & i_mask) != 0 )
		{
			p_dlg->SetChannelRange(index_channel, ME7_AI_RANGE_50_AMPERE);
		}

		i_mask<<= 2;
	}

	return(0);
}


void CDlg_M7_TestDlg::OnCancel()
{
	// TODO: Add your specialized code here and/or call the base class

	int i_me_error = meIOIrqStop(	m_iME7DeviceIndex,				// Device index
									m_iME7AISubdeviceIndex,			// Subdevice index
									0,								// Channel index 	
									ME_IO_IRQ_STOP_NO_FLAGS		);	// Flags

	meClose(0);

	CDialog::OnCancel();
}

void CDlg_M7_TestDlg::OnBnClickedButtonZeroAdjustChannel0()
{
	// TODO: Add your control notification handler code here

	OnZeroAdjust(0);
}

void CDlg_M7_TestDlg::OnBnClickedButtonZeroAdjustChannel1()
{
	// TODO: Add your control notification handler code here

	OnZeroAdjust(1);
}

void CDlg_M7_TestDlg::OnBnClickedButtonZeroAdjustChannel2()
{
	// TODO: Add your control notification handler code here

	OnZeroAdjust(2);
}

void CDlg_M7_TestDlg::OnBnClickedButtonZeroAdjustChannel3()
{
	// TODO: Add your control notification handler code here

	OnZeroAdjust(3);
}

void CDlg_M7_TestDlg :: OnZeroAdjust(int iChannel)
{
	meIOSingle_t io_single[1];
	 
	io_single[0].iDevice = m_iME7DeviceIndex;
	 
	io_single[0].iSubdevice = m_iME7AISubdeviceIndex;
	io_single[0].iChannel   = iChannel;
	io_single[0].iDir       = ME_DIR_SET_OFFSET;                      
	io_single[0].iValue     = 0;
	io_single[0].iTimeOut   = 0;                                      
	io_single[0].iFlags     = ME_IO_SINGLE_TYPE_NO_FLAGS;
	 
	                  
	int i_me_error = meIOSingle(&io_single[0],                // Output list 
								1,                            // Number of elements in the above list 
								ME_IO_SINGLE_NO_FLAGS   );    // Flags
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel4Range0()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(4, 0);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel4Range10()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(4, 10);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel4Range11()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(4, 11);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel4Range12()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(4, 12);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel5Range0()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(5, 0);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel5Range10()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(5, 10);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel5Range11()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(5, 11);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel5Range12()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(5, 12);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel6Range0()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(6, 0);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel6Range10()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(6, 10);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel6Range11()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(6, 11);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel6Range12()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(6, 12);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel7Range0()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(7, 0);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel7Range10()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(7, 10);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel7Range11()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(7, 11);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel7Range12()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(7, 12);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel8Range0()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(8, 0);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel8Range10()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(8, 10);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel8Range11()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(8, 11);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel8Range12()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(8, 12);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel9Range0()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(9, 0);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel9Range10()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(9, 10);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel9Range11()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(9, 11);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel9Range12()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(9, 12);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel10Range0()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(10, 0);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel10Range10()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(10, 10);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel10Range11()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(10, 11);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel10Range12()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(10, 12);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel11Range0()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(11, 0);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel11Range10()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(11, 10);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel11Range11()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(11, 11);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel11Range12()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(11, 12);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel12Range0()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(12, 0);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel12Range10()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(12, 10);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel12Range11()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(12, 11);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel12Range12()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(12, 12);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel13Range0()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(13, 0);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel13Range10()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(13, 10);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel13Range11()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(13, 11);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel13Range12()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(13, 12);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel14Range0()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(14, 0);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel14Range10()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(14, 10);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel14Range11()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(14, 11);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel14Range12()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(14, 12);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel15Range0()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(15, 0);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel15Range10()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(15, 10);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel15Range11()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(15, 11);
}

void CDlg_M7_TestDlg::OnBnClickedButtonChannel15Range12()
{
	// TODO: Add your control notification handler code here

	SetChannelRange(15, 12);
}
